VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Dictionary"
   ClientHeight    =   4920
   ClientLeft      =   150
   ClientTop       =   750
   ClientWidth     =   6105
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   328
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   407
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdExit 
      Caption         =   "&Exit"
      Height          =   375
      Left            =   4560
      TabIndex        =   5
      Top             =   4320
      Width           =   1335
   End
   Begin VB.CommandButton cmdDelete 
      Caption         =   "&Delete"
      Height          =   375
      Left            =   3120
      TabIndex        =   4
      Top             =   4320
      Width           =   1335
   End
   Begin VB.CommandButton cmdEdit 
      Caption         =   "&Edit"
      Height          =   375
      Left            =   1680
      TabIndex        =   3
      Top             =   4320
      Width           =   1335
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "&Add"
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   4320
      Width           =   1335
   End
   Begin VB.TextBox txtDescription 
      Height          =   3375
      Left            =   240
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   600
      Width           =   5655
   End
   Begin VB.ComboBox cmbWord 
      Height          =   315
      Left            =   240
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   240
      Width           =   5655
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuNewDictionary 
         Caption         =   "&New Dictionary"
      End
      Begin VB.Menu mnuOpenDictionary 
         Caption         =   "&Open Dictionary"
      End
      Begin VB.Menu mnuLine 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSave 
         Caption         =   "&Save Dictionary"
      End
      Begin VB.Menu mnuSaveAs 
         Caption         =   "S&ave Dictionary As"
      End
      Begin VB.Menu mnuLine2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuAddWord 
         Caption         =   "&Add Word"
      End
      Begin VB.Menu mnuEditWord 
         Caption         =   "&Edit Word"
      End
      Begin VB.Menu mnuDeleteWord 
         Caption         =   "&Delete Word"
      End
      Begin VB.Menu mnuLine3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditDictionary 
         Caption         =   "&Edit Dictionary"
      End
   End
   Begin VB.Menu mnuAbout 
      Caption         =   "&About"
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Copyright (C) 2004 Kristian. S.Stangeland

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Dim WithEvents Dictionary As clsDictionary
Attribute Dictionary.VB_VarHelpID = -1

Dim Dialog As New clsDialog
Dim OpenSave As New clsOpenSave

' To avoid entering the password several times
Dim currentPassword As String

Private Sub cmbWord_Change()

    txtDescription.Text = Dictionary.WordDescription(cmbWord.ListIndex)
    
End Sub

Private Sub cmbWord_Click()

    ' Update the description-area
    cmbWord_Change

End Sub

Private Sub cmdAdd_Click()

    Dim PropBag As PropertyBag

    ' Use the word-form
    Set Dialog.ReferenceForm = frmWord
    
     ' Show the dialog and retrive the result-data
    Set PropBag = Dialog.ShowDialog(New PropertyBag, "Add word")
    
    ' If the result was OK
    If PropBag.ReadProperty("Returned") = "OK" Then
        ' Add the word
        Dictionary.AddWord PropBag.ReadProperty("txtWord", ""), PropBag.ReadProperty("txtDescription", "")
    End If

End Sub

Private Sub cmdDelete_Click()

    ' If we have selected something
    If cmbWord.ListIndex < 0 Then
        ' We cannot edit when no elements are selected
        Exit Sub
    End If
    
    ' Check the password
    If Not IsPassCorrect(currentPassword) Then
        Exit Sub
    End If
    
    ' Delete the word
    Dictionary.DeleteWord cmbWord.ListIndex

End Sub

Private Sub cmdEdit_Click()

    Dim PropBag As PropertyBag, SendProp As New PropertyBag

    ' If we have selected something
    If cmbWord.ListIndex < 0 Then
        ' We cannot edit when no elements are selected
        Exit Sub
    End If

    ' Check the password
    If Not IsPassCorrect(currentPassword) Then
        Exit Sub
    End If

    ' Use the word-form
    Set Dialog.ReferenceForm = frmWord

    ' Send the original data
    SendProp.WriteProperty "txtWord", Dictionary.WordName(cmbWord.ListIndex), ""
    SendProp.WriteProperty "txtDescription", Dictionary.WordDescription(cmbWord.ListIndex), ""
    
    ' Show the dialog and retrive the result-data
    Set PropBag = Dialog.ShowDialog(SendProp, "Edit word")
    
    ' If the result was OK
    If PropBag.ReadProperty("Returned") = "OK" Then
        ' Update the words
        Dictionary.WordName(cmbWord.ListIndex) = PropBag.ReadProperty("txtWord", "")
        Dictionary.WordDescription(cmbWord.ListIndex) = PropBag.ReadProperty("txtDescription", "")
    End If

End Sub

Private Sub cmdExit_Click()

    ' Exit the program
    Unload Me

End Sub

Private Sub Dictionary_Opened()

    ' Update the dictionary when opened
    UpdateDictionary

End Sub

Private Sub Dictionary_Renewed()

    ' Also when its renewed
    UpdateDictionary

End Sub

Private Sub Dictionary_Changed(WordAmoutChanged As Boolean)

    UpdateDictionary

End Sub

Private Sub Dictionary_Closing()

    ' If the dictionary contains elements and it has been changed, ask to save it
    If Dictionary.WordCount >= 0 And Dictionary.DictionaryChanged Then
        
        If MsgBox("Do you want to save the changes", vbQuestion + vbYesNo, "Save") = vbYes Then
            Dictionary.SaveDictionary Dictionary.FileName
        End If
        
    End If

End Sub

Private Sub Form_Load()

    ' Create the dictionary-object
    Set Dictionary = New clsDictionary

End Sub

' This method is much better than using the END-statement
Private Sub Form_Unload(Cancel As Integer)

    Dim Form As Form

    ' Check and see if we need to save the dictionary
    Dictionary_Closing
    
    ' Unload all forms
    For Each Form In Forms
        Unload Form
    Next

End Sub

Private Sub mnuAbout_Click()
    
    ' Who has made this program
    MsgBox "This program is made by Kristian S. Stangeland", vbInformation, "About"

End Sub

Private Sub mnuAddWord_Click()

    ' Simply invoke the cmdAdd-event
    cmdAdd_Click

End Sub

Private Sub mnuDeleteWord_Click()

    ' Simply invoke the cmdDelete-event
    cmdDelete_Click

End Sub

Private Sub mnuEditDictionary_Click()

    Dim PropBag As PropertyBag, SendProp As New PropertyBag

    ' Check the password
    If Not IsPassCorrect(currentPassword) Then
        Exit Sub
    End If

    ' Use the dictionary-form
    Set Dialog.ReferenceForm = frmDictionary
    
    ' Use the original data
    SendProp.WriteProperty "txtName", Dictionary.DictionaryName, ""
    SendProp.WriteProperty "txtAuthor", Dictionary.DictionaryAuthor, ""
    SendProp.WriteProperty "txtPassword", Dictionary.DictionaryPassword, ""
    SendProp.WriteProperty "txtReEnterPassword", Dictionary.DictionaryPassword, ""
    
    ' Show the dialog and retrive the result-data
    Set PropBag = Dialog.ShowDialog(SendProp)

    ' If the result was OK
    If PropBag.ReadProperty("Returned") = "OK" Then
        Dictionary.DictionaryName = PropBag.ReadProperty("txtName", "")
        Dictionary.DictionaryAuthor = PropBag.ReadProperty("txtAuthor", "")
        Dictionary.DictionaryPassword = PropBag.ReadProperty("txtPassword", "")
        Dictionary.DictionaryPassword = PropBag.ReadProperty("txtPassword", "")
    End If

End Sub

Private Sub mnuEditWord_Click()

    ' Simply invoke the cmdEdit-event
    cmdEdit_Click

End Sub

Private Sub mnuExit_Click()

    ' Exit the program
    Unload Me

End Sub

Private Sub mnuNewDictionary_Click()

    Dim PropBag As PropertyBag

    ' Use the dictionary-form
    Set Dialog.ReferenceForm = frmDictionary
    
    ' Show the dialog and retrive the result-data
    Set PropBag = Dialog.ShowDialog(New PropertyBag)

    ' If the result was OK
    If PropBag.ReadProperty("Returned") = "OK" Then
        Dictionary.CreateDictionary PropBag.ReadProperty("txtPassword", ""), PropBag.ReadProperty("txtAurthor", ""), PropBag.ReadProperty("txtName", "")
    End If

End Sub

Public Sub UpdateDictionary()

    ' Clear all the words
    cmbWord.Clear

    ' Fill the combo-box with words
    Dictionary.FillComboBox cmbWord

    If cmbWord.ListCount > 0 Then
        cmbWord.ListIndex = 0
    End If

End Sub

Public Function IsPassCorrect(sPassword As String) As Boolean

    If Dictionary.DictionaryPassword <> "" Then
    
        If Dictionary.DictionaryPassword = currentPassword Then
        
            ' The password is already correct
            IsPassCorrect = True
        
        Else
        
            ' Ask for the password
            sPassword = InputBox("This dictionary is password-protected. Please state the password:")
            
            If sPassword = Dictionary.DictionaryPassword Then
            
                ' The password is correct
                IsPassCorrect = True
                
            Else
            
                ' The password stated isn't correct
                MsgBox "Wrong password", vbCritical, "Error"
            
            End If
        
        End If
    
    Else
    
        ' This dictionary hasn't got a password
        IsPassCorrect = True
    
    End If

End Function

Private Sub mnuOpenDictionary_Click()
 
    ' Set the filter
    OpenSave.Filter = "Dictionary database (*.dyb)" & Chr(0) & "*.dyb"
    
    ' Show the open-dialog
    OpenSave.OpenFile Me.hwnd, "Open dictionary"

    ' If we haven't canceled, try to open the file
    If OpenSave.File <> "" Then
    
        If Dictionary.OpenDictionary(OpenSave.File) < 0 Then
            ' We couln't open the dictionary
            MsgBox "Could not open dictionary", vbCritical, "Error"
            
            ' Reset the current dictionary (something might have destroyed the array)
            Dictionary.DictionaryChanged = False
            Dictionary.CreateDictionary "", "", ""
        End If
    
    End If

End Sub

Private Sub mnuSaveAs_Click()

    ' Set the filter
    OpenSave.Filter = "Dictionary database (*.dyb)" & Chr(0) & "*.dyb"
    
    ' Show the save-dialog
    OpenSave.SaveFile Me.hwnd, "Save dictionary"

    ' If it dosen't end with ".dyb", add it:
    If LCase(Right(OpenSave.File, 4)) <> ".dyb" Then
        OpenSave.File = OpenSave.File & ".dyb"
    End If
    
    ' If we haven't canceled, try to save the file
    If OpenSave.File <> "" Then
    
        If Dictionary.SaveDictionary(OpenSave.File) < 0 Then
            ' We couln't open the dictionary
            MsgBox "Could not save dictionary", vbCritical, "Error"
        End If
    
    End If

End Sub

Private Sub mnuSave_Click()

    ' If this has been saved before
    If Dictionary.FileName <> "" Then
    
        ' Save the dictionary
        If Dictionary.SaveDictionary(Dictionary.FileName) < 0 Then
            ' We couln't open the dictionary
            MsgBox "Could not save dictionary", vbCritical, "Error"
        End If
        
    Else
    
        ' Use save as
        mnuSaveAs_Click
    
    End If

End Sub


